diff --git a/tools/normalize.py b/tools/normalize.py
deleted file mode 100755
index 7d87c5e..0000000
--- a/tools/normalize.py
+++ /dev/null
@@ -1,33 +0,0 @@
-#!/usr/bin/env python2
-
-import sys, subprocess
-
-if len(sys.argv) > 2:
-    ifile  = sys.argv[1]
-    encopt = sys.argv[2:-1]
-    ofile  = sys.argv[-1]
-else:
-    print 'usage: %s <input> [encode_options] <output>' % sys.argv[0]
-    sys.exit(1)
-
-analysis_cmd  = 'ffprobe -v error -of compact=p=0:nk=1 '
-analysis_cmd += '-show_entries frame_tags=lavfi.r128.I -f lavfi '
-analysis_cmd += "amovie='%s',ebur128=metadata=1" % ifile
-try:
-    probe_out = subprocess.check_output(analysis_cmd, shell=True)
-except subprocess.CalledProcessError, e:
-    sys.exit(e.returncode)
-loudness = ref = -23
-for line in probe_out.splitlines():
-    sline = line.rstrip()
-    if sline:
-        loudness = sline
-adjust = ref - float(loudness)
-if abs(adjust) < 0.0001:
-    print 'No normalization needed for ' + ifile
-else:
-    print "Adjust %s by %.1fdB" % (ifile, adjust)
-    norm_cmd  = ['ffmpeg', '-i', ifile, '-af', 'volume=%fdB' % adjust]
-    norm_cmd += encopt + [ofile]
-    print ' => %s' % ' '.join(norm_cmd)
-    subprocess.call(norm_cmd)
diff --git a/tools/python/normalize.py b/tools/python/normalize.py
new file mode 100755
index 0000000..7d87c5e
--- /dev/null
+++ b/tools/python/normalize.py
@@ -0,0 +1,33 @@
+#!/usr/bin/env python2
+
+import sys, subprocess
+
+if len(sys.argv) > 2:
+    ifile  = sys.argv[1]
+    encopt = sys.argv[2:-1]
+    ofile  = sys.argv[-1]
+else:
+    print 'usage: %s <input> [encode_options] <output>' % sys.argv[0]
+    sys.exit(1)
+
+analysis_cmd  = 'ffprobe -v error -of compact=p=0:nk=1 '
+analysis_cmd += '-show_entries frame_tags=lavfi.r128.I -f lavfi '
+analysis_cmd += "amovie='%s',ebur128=metadata=1" % ifile
+try:
+    probe_out = subprocess.check_output(analysis_cmd, shell=True)
+except subprocess.CalledProcessError, e:
+    sys.exit(e.returncode)
+loudness = ref = -23
+for line in probe_out.splitlines():
+    sline = line.rstrip()
+    if sline:
+        loudness = sline
+adjust = ref - float(loudness)
+if abs(adjust) < 0.0001:
+    print 'No normalization needed for ' + ifile
+else:
+    print "Adjust %s by %.1fdB" % (ifile, adjust)
+    norm_cmd  = ['ffmpeg', '-i', ifile, '-af', 'volume=%fdB' % adjust]
+    norm_cmd += encopt + [ofile]
+    print ' => %s' % ' '.join(norm_cmd)
+    subprocess.call(norm_cmd)
diff --git a/tools/python/zmqshell.py b/tools/python/zmqshell.py
new file mode 100755
index 0000000..a7d1126
--- /dev/null
+++ b/tools/python/zmqshell.py
@@ -0,0 +1,26 @@
+#!/usr/bin/env python2
+
+import sys, zmq, cmd
+
+class LavfiCmd(cmd.Cmd):
+    prompt = 'lavfi> '
+
+    def __init__(self, bind_address):
+        context = zmq.Context()
+        self.requester = context.socket(zmq.REQ)
+        self.requester.connect(bind_address)
+        cmd.Cmd.__init__(self)
+
+    def onecmd(self, cmd):
+        if cmd == 'EOF':
+            sys.exit(0)
+        print 'Sending command:[%s]' % cmd
+        self.requester.send(cmd)
+        message = self.requester.recv()
+        print 'Received reply:[%s]' % message
+
+try:
+    bind_address = sys.argv[1] if len(sys.argv) > 1 else "tcp://localhost:5555"
+    LavfiCmd(bind_address).cmdloop('FFmpeg libavfilter interactive shell')
+except KeyboardInterrupt:
+    pass
diff --git a/tools/zmqshell.py b/tools/zmqshell.py
deleted file mode 100755
index a7d1126..0000000
--- a/tools/zmqshell.py
+++ /dev/null
@@ -1,26 +0,0 @@
-#!/usr/bin/env python2
-
-import sys, zmq, cmd
-
-class LavfiCmd(cmd.Cmd):
-    prompt = 'lavfi> '
-
-    def __init__(self, bind_address):
-        context = zmq.Context()
-        self.requester = context.socket(zmq.REQ)
-        self.requester.connect(bind_address)
-        cmd.Cmd.__init__(self)
-
-    def onecmd(self, cmd):
-        if cmd == 'EOF':
-            sys.exit(0)
-        print 'Sending command:[%s]' % cmd
-        self.requester.send(cmd)
-        message = self.requester.recv()
-        print 'Received reply:[%s]' % message
-
-try:
-    bind_address = sys.argv[1] if len(sys.argv) > 1 else "tcp://localhost:5555"
-    LavfiCmd(bind_address).cmdloop('FFmpeg libavfilter interactive shell')
-except KeyboardInterrupt:
-    pass